# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

import Preferences

from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

PIPS = (None, ((0.0, 0.0),), ((-0.6, -0.6), (0.6,0.6)), ((-0.6, -0.6), (0.6,0.6), (0,0)),
              ((-0.5, -0.5), (0.5,0.5), (0.5, -0.5), (-0.5,0.5)),
              ((-0.6, -0.6), (0.6,0.6), (0.6, -0.6), (-0.6,0.6), (0,0)),
              ((-0.5, -0.6), (0.5,0.6), (0.5, -0.6), (-0.5,0.6), (0.5,0), (-0.5, 0)),)

def drawCell(state, coord, value, scale):
    if value!=0:
        pnum = (1 if value>0 else 2)
        glMaterialfv(GL_FRONT, GL_DIFFUSE, Preferences.prefs.player_color(pnum, as_float=True))
        # for 2d board, shift foward so we draw above the board, and reduce from normal size slightly
        if len(coord)==2:
            scale *= 0.75
            glTranslatef(0, 0, scale)
            
        glutSolidCube(scale*2)
        glMaterialfv(GL_FRONT,GL_DIFFUSE,(1,1,1))
        # draw pips as 2d discs, slightly above/below the die cube
        quadric = gluNewQuadric()
        for x,y in PIPS[abs(value)]:
            glPushMatrix()
            glTranslate(x*scale, y*scale, scale*1.01)
            gluDisk(quadric, 0, 0.2*scale, 15, 15)
            glTranslate(0, 0, -2*scale*1.01)
            gluDisk(quadric, 0, 0.2*scale, 15, 15)
            glPopMatrix()
        return True
